
package de.ivu.elect.presentation.ergebnis.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.faces.FacesContextUtil;

@Named(ErgebnisZurBearbeitungAuswaehlenAction.COMPONENT_NAME)
public class ErgebnisZurBearbeitungAuswaehlenAction extends AbstractErgebnisAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisZurBearbeitungAuswaehlenAction";

  @Inject
  private ErgebnisSessionSelect ergebnisSessionSelect;

  @Override
  public boolean isDisabledInternal(@Nonnull Ergebnis entity) {
    return isCurrentlySelectedErgebnis(entity);
  }

  @Override
  protected String doIt(Ergebnis entity) {
    setCurrentlySelectedErgebnis(entity);

    messages.addInfoMessage("ergebnis.edit.action.select.success.message", entity.getName());

    return FacesContextUtil.getCurrentViewId();
  }

  private boolean isCurrentlySelectedErgebnis(Ergebnis entity) {
    return ergebnisSessionSelect.isSelected() && ergebnisSessionSelect.getEntity().equals(entity);
  }

  private void setCurrentlySelectedErgebnis(Ergebnis entity) {
    ergebnisSessionSelect.setEntity(entity);
  }

  @Override
  public String getLabelKey() {
    return "ergebnis.edit.action.select";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconFolderOpen();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHL_ZUR_BEARBEITUNG_AUSWAEHLEN;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }
}
